<template>
  <div class="lecture-live-item-wrapper" style="background: #e5e9f2">
    <div v-if="data === undefined && type !== 'TEACHER'">
      <!-- 입력값 없음 -->
      {{ $t("TEACHER_CLASS.WAIT_SIGNAL") }}
    </div>
    <div v-else class="lecture-item">
      <div v-if="[0, 7].includes(data.type)" class="question-box">
        <!-- 질문 -->
        <div v-if="data.questions[0].type === 0">
          <p class="question-type">
            {{ $t("ITEM.QUESTION") }} - {{ $t("QUESTION.MULTI_ANS") }}
          </p>
          <p
            v-if="(studentAnswerLogIndex !== -1 || answerSubmitted) && type === 'STUDENT'"
            style="color: red"
          >
            {{ $t("STUDENT_LECTURE.SUB_COM") }}
          </p>
          <div
            v-show="
              data.questions[0].question_material &&
              data.questions[0].question_material.length > 0
            "
          >
            <div
              class="questionFile"
              v-for="file in data.questions[0].question_material"
              :key="file.file_guid"
            >
              <img
                v-if="
                  ['.jpg', '.png', '.gif', '.JPG', '.PNG', '.GIF'].includes(
                    file.file_type
                  )
                "
                :src="getUrl(file.client_path)"
                width="100%"
              />
              <div class="questionNoteWrap">
                <video
                  v-if="['.mp4', '.MP4'].includes(file.file_type)"
                  :src="getUrl(file.client_path)"
                  controls
                ></video>
              </div>
            </div>
          </div>
          <div
            class="videoPlayer"
            v-if="data.questions[0].question_media_type === 'youtube'"
          >
            <iframe
              width="100%"
              :src="`https://www.youtube.com/embed/${youtubeId(
                data.questions[0].question_media
              )}?mute=1&autoplay=1&modestbranding=1`"
              frameborder="0"
              allowfullscreen
            >
            </iframe>
          </div>
          <audio
            v-if="data.questions[0].question_media_type === 'voice'"
            :src="data.questions[0].question_media"
            controls
          ></audio>
          <pre>{{ data.questions[0].question }}</pre>
          <el-checkbox-group v-model="answer" style="width: 100%">
            <div
              v-for="(choice, index) in data.questions[0].choice"
              :key="index"
              class="radio-one"
            >
              <el-checkbox :label="(index + 1).toString()">
                <span
                  v-if="
                    data.questions[0].multi_choice_media_type === 'none' ||
                    data.questions[0].multi_choice_media_type === undefined ||
                    data.questions[0].multi_choice_media_type === null
                  "
                  style="font-size: 15px"
                >
                  {{ index + 1 }} . {{ choice }}
                </span>
              </el-checkbox>
              <br />
              <div
                class="videoPlayer"
                v-if="
                  data.questions[0].multi_choice_media_type === 'youtube' &&
                  data.questions[0].choice[index] !== '' &&
                  data.questions[0].choice[index] !== undefined
                "
              >
                <iframe
                  width="100%"
                  :src="`https://www.youtube.com/embed/${youtubeId(
                    data.questions[0].choice[index]
                  )}?mute=1&modestbranding=1`"
                  frameborder="0"
                  allowfullscreen
                >
                </iframe>
              </div>
              <img
                v-if="
                  data.questions[0].multi_choice_media_type === 'image' &&
                  data.questions[0].choice[index] !== '' &&
                  data.questions[0].choice[index] !== undefined
                "
                :src="getUrl(data.questions[0].choice[index])"
                width="60%"
              />
              <audio
                v-if="data.questions[0].multi_choice_media_type === 'voice'"
                :src="data.questions[0].choice[index]"
                controls
              ></audio>
            </div>
          </el-checkbox-group>
        </div>
        <div v-if="data.questions[0].type === 1">
          <p>{{ $t("ITEM.QUESTION") }} - {{ $t("QUESTION.SHORT_ANS") }}</p>
          <p
            v-if="(studentAnswerLogIndex !== -1 || answerSubmitted) && type === 'STUDENT'"
            style="color: red"
          >
            {{ $t("STUDENT_LECTURE.SUB_COM") }}
          </p>
          <div
            v-show="
              data.questions[0].question_material &&
              data.questions[0].question_material.length > 0
            "
          >
            <div
              class="questionFile"
              v-for="file in data.questions[0].question_material"
              :key="file.file_guid"
            >
              <img
                v-if="
                  ['.jpg', '.png', '.gif', '.JPG', '.PNG', '.GIF'].includes(
                    file.file_type
                  )
                "
                :src="getUrl(file.client_path)"
                width="100%"
              />
              <div class="questionNoteWrap">
                `
                <video
                  v-if="['.mp4', '.MP4'].includes(file.file_type)"
                  :src="getUrl(file.client_path)"
                  controls
                ></video>
              </div>
            </div>
          </div>
          <div
            class="videoPlayer"
            v-if="data.questions[0].question_media_type === 'youtube'"
          >
            <iframe
              width="100%"
              :src="`https://www.youtube.com/embed/${youtubeId(
                data.questions[0].question_media
              )}?mute=1&autoplay=1&modestbranding=1`"
              frameborder="0"
              allowfullscreen
            >
            </iframe>
          </div>
          <audio
            v-if="data.questions[0].question_media_type === 'voice'"
            :src="data.questions[0].question_media"
            controls
          ></audio>
          <pre>{{ data.questions[0].question }}</pre>
          <el-input
            :placeholder="$t('QUESTION.ENTER_CON')"
            v-model="answer[0]"
            :maxlength="limitLength"
          >
          </el-input>
        </div>
        <div v-if="data.questions[0].type === 2">
          <p>{{ $t("ITEM.QUESTION") }} - {{ $t("QUESTION.ESSAY") }}</p>
          <p
            v-if="(studentAnswerLogIndex !== -1 || answerSubmitted) && type === 'STUDENT'"
            style="color: red"
          >
            {{ $t("STUDENT_LECTURE.SUB_COM") }}
          </p>
          <div v-show="data.questions[0].question_material.length > 0">
            <div
              class="questionFile"
              v-for="file in data.questions[0].question_material"
              :key="file.file_guid"
            >
              <img
                v-if="
                  ['.jpg', '.png', '.gif', '.JPG', '.PNG', '.GIF'].includes(
                    file.file_type
                  )
                "
                :src="getUrl(file.client_path)"
                width="100%"
              />
              <div class="questionNoteWrap">
                <video
                  v-if="['.mp4', '.MP4'].includes(file.file_type)"
                  :src="getUrl(file.client_path)"
                  controls
                ></video>
              </div>
            </div>
          </div>
          <div
            class="videoPlayer"
            v-if="data.questions[0].question_media_type === 'youtube'"
          >
            <iframe
              width="100%"
              :src="`https://www.youtube.com/embed/${youtubeId(
                data.questions[0].question_media
              )}?mute=1&autoplay=1&modestbranding=1`"
              frameborder="0"
              allowfullscreen
            >
            </iframe>
          </div>
          <audio
            v-if="data.questions[0].question_media_type === 'voice'"
            :src="data.questions[0].question_media"
            controls
          ></audio>
          <pre>{{ data.questions[0].question }}</pre>
          <el-input
            class="margin-text"
            :placeholder="$t('QUESTION.ENTER_CON')"
            v-model="answer[0]"
            type="textarea"
            :maxlength="limitLength"
            :autosize="{ minRows: 10, maxRows: 15 }"
          >
          </el-input>
        </div>
        <div v-if="data.questions[0].type === 3">
          <p>{{ $t("ITEM.QUESTION") }} - SW</p>
          <p
            v-if="(studentAnswerLogIndex !== -1 || answerSubmitted) && type === 'STUDENT'"
            style="color: red"
          >
            {{ $t("STUDENT_LECTURE.SUB_COM") }}
          </p>
          <div v-show="data.questions[0].question_material.length > 0">
            <div
              class="questionFile"
              v-for="file in data.questions[0].question_material"
              :key="file.file_guid"
            >
              <img
                v-if="
                  ['.jpg', '.png', '.gif', '.JPG', '.PNG', '.GIF'].includes(
                    file.file_type
                  )
                "
                :src="getUrl(file.client_path)"
                width="100%"
              />
              <div class="questionNoteWrap">
                <video
                  v-if="['.mp4', '.MP4'].includes(file.file_type)"
                  :src="getUrl(file.client_path)"
                  controls
                ></video>
              </div>
            </div>
          </div>
          <div
            class="videoPlayer"
            v-if="data.questions[0].question_media_type === 'youtube'"
          >
            <iframe
              width="100%"
              :src="`https://www.youtube.com/embed/${youtubeId(
                data.questions[0].question_media
              )}?mute=1&autoplay=1&modestbranding=1`"
              frameborder="0"
              allowfullscreen
            >
            </iframe>
          </div>
          <audio
            v-if="data.questions[0].question_media_type === 'voice'"
            :src="data.questions[0].question_media"
            controls
          ></audio>
          <pre>{{ data.questions[0].question }}</pre>
          <pre
            >{{ $t("QUESTION.LANG") }} : {{ data.questions[0].accept_language[0] }}</pre
          >
          <!-- 없는 항목은 보이지 않게 190426 -->
          <div v-if="data.questions[0].input_description !== ''">
            <p>{{ $t("QUESTION.INPUT") }} :</p>
            <pre>{{ data.questions[0].input_description }}</pre>
          </div>
          <div v-if="data.questions[0].output_description !== ''">
            <p>{{ $t("QUESTION.OUTPUT") }} :</p>
            <pre>{{ data.questions[0].output_description }}</pre>
          </div>
          <div v-if="data.questions[0].sample_input !== ''">
            <p>{{ $t("QUESTION.INPUT_SAMPLE") }} :</p>
            <pre>{{ data.questions[0].sample_input }}</pre>
          </div>
          <div v-if="data.questions[0].sample_output !== ''">
            <p>{{ $t("QUESTION.OUTPUT_SAMPLE") }} :</p>
            <pre>{{ data.questions[0].sample_output }}</pre>
          </div>
          <div v-if="authType === 1">
            <div
              v-for="testcase in data.questions[0].problem_testcases"
              :key="testcase.num"
            >
              <p>
                {{ $t("QUESTION.TEST_CASE") }} {{ testcase.num }}
                {{ $t("QUESTION.IN") }} :
              </p>
              <pre>{{ testcase.input }} </pre>
              <p>
                {{ $t("QUESTION.TEST_CASE") }} {{ testcase.num }}
                {{ $t("QUESTION.OUT") }} :
              </p>
              <pre>{{ testcase.output }} </pre>
            </div>
          </div>
          <el-input
            class="margin-text"
            :placeholder="$t('QUESTION.ENTER_CON')"
            v-model="answer[0]"
            type="textarea"
            :autosize="{ minRows: 10, maxRows: 15 }"
          ></el-input>
        </div>
        <div v-if="data.questions[0].type === 4">
          <p>{{ $t("ITEM.QUESTION") }} - SQL</p>
          <p
            v-if="(studentAnswerLogIndex !== -1 || answerSubmitted) && type === 'STUDENT'"
            style="color: red"
          >
            {{ $t("STUDENT_LECTURE.SUB_COM") }}
          </p>
          <div v-show="data.questions[0].question_material.length > 0">
            <div
              class="questionFile"
              v-for="file in data.questions[0].question_material"
              :key="file.file_guid"
            >
              <img
                v-if="
                  ['.jpg', '.png', '.gif', '.JPG', '.PNG', '.GIF'].includes(
                    file.file_type
                  )
                "
                :src="getUrl(file.client_path)"
                width="100%"
              />
              <div class="questionNoteWrap">
                <video
                  v-if="['.mp4', '.MP4'].includes(file.file_type)"
                  :src="getUrl(file.client_path)"
                  controls
                ></video>
              </div>
            </div>
          </div>
          <div
            class="videoPlayer"
            v-if="data.questions[0].question_media_type === 'youtube'"
          >
            <iframe
              width="100%"
              :src="`https://www.youtube.com/embed/${youtubeId(
                data.questions[0].question_media
              )}?mute=1&autoplay=1&modestbranding=1`"
              frameborder="0"
              allowfullscreen
            >
            </iframe>
          </div>
          <audio
            v-if="data.questions[0].question_media_type === 'voice'"
            :src="data.questions[0].question_media"
            controls
          ></audio>
          <pre>{{ data.questions[0].question }}</pre>
          <el-input
            :placeholder="$t('QUESTION.ENTER_CON')"
            v-model="answer[0]"
            type="textarea"
            :autosize="{ minRows: 10, maxRows: 15 }"
          ></el-input>
        </div>
        <div v-if="data.questions[0].type === 5">
          <p>{{ $t("ITEM.QUESTION") }} - VIDEO</p>
          <p
            v-if="(studentAnswerLogIndex !== -1 || answerSubmitted) && type === 'STUDENT'"
            style="color: red"
          >
            {{ $t("STUDENT_LECTURE.SUB_COM") }}
          </p>
          <div v-show="data.questions[0].question_material.length > 0">
            <div
              class="questionFile"
              v-for="file in data.questions[0].question_material"
              :key="file.file_guid"
            >
              <img
                v-if="
                  ['.jpg', '.png', '.gif', '.JPG', '.PNG', '.GIF'].includes(
                    file.file_type
                  )
                "
                :src="getUrl(file.client_path)"
                width="100%"
              />
              <div class="questionNoteWrap">
                <video
                  v-if="['.mp4', '.MP4'].includes(file.file_type)"
                  :src="getUrl(file.client_path)"
                  controls
                ></video>
              </div>
            </div>
          </div>
          <div
            class="videoPlayer"
            v-if="data.questions[0].question_media_type === 'youtube'"
          >
            <iframe
              width="100%"
              :src="`https://www.youtube.com/embed/${youtubeId(
                data.questions[0].question_media
              )}?mute=1&autoplay=1&modestbranding=1`"
              frameborder="0"
              allowfullscreen
            >
            </iframe>
          </div>
          <audio
            v-if="data.questions[0].question_media_type === 'voice'"
            :src="data.questions[0].question_media"
            controls
          ></audio>
          <pre>{{ data.questions[0].question }}</pre>
          <span>&nbsp;&nbsp;&nbsp;{{ $t("QUESTION.UPLOAD_INPUT") }}</span>
          <el-popover placement="top-start" trigger="hover">
            {{ $t("QUESTION.UPLOAD_HELP") }}
            <i class="el-icon-question fa-lg" slot="reference"></i>
          </el-popover>
          <el-input :placeholder="$t('QUESTION.VIDEO_ID')" v-model="answer[0]"></el-input>
          <div
            class="videoPlayer"
            v-if="data.questions[0].question_media_type === 'youtube'"
          >
            <iframe
              width="100%"
              :src="`https://www.youtube.com/embed/${answer[0]}?mute=1&modestbranding=1`"
              frameborder="0"
              allowfullscreen
            >
            </iframe>
          </div>
        </div>
        <div v-if="data.questions[0].type === 6">
          <span>{{ $t("QUESTION.QUESTION") }} : {{ data.questions[0].question }}</span>
          <div v-if="data.questions[0].answer_media_type === 'youtube'">
            <el-input
              :placeholder="$t('QUESTION.ENTER_YOUTUBE_URL')"
              v-model="answer[0]"
            ></el-input>
            <div class="videoPlayer" v-if="answer[0] !== undefined && answer[0] !== ''">
              <iframe
                width="100%"
                :src="`https://www.youtube.com/embed/${youtubeId(
                  answer[0]
                )}?mute=1&autoplay=1&modestbranding=1`"
                frameborder="0"
                allowfullscreen
              >
              </iframe>
            </div>
          </div>
          <div v-if="data.questions[0].answer_media_type === 'image'">
            <el-upload
              style="display: span"
              action="#"
              :auto-upload="false"
              :on-exceed="handleExceed"
              :limit="1"
              ref="answerUpload"
            >
              <el-button
                :title="$t('UPLOAD.SUB_IMG')"
                type="primary"
                icon="fas fa-file-image"
              ></el-button>
              <span slot="tip" class="el-upload__tip">
                {{ $t("UPLOAD.ONLY_ONE_IMG") }}</span
              >
            </el-upload>
          </div>
          <div v-if="data.questions[0].answer_media_type === 'voice'">
            <div v-if="isRecording === false">
              <el-button
                type="primary"
                :title="$t('UPLOAD.VOICE_RECORDING')"
                icon="fa fa-microphone"
                @click="startRecording"
              ></el-button>
              <span style="margin-left: 10px" slot="tip" class="el-upload__tip">{{
                $t("UPLOAD.PRESS_RECORDING")
              }}</span>
            </div>
            <div v-if="isRecording === true">
              <el-button
                type="danger"
                :title="$t('UPLOAD.VOICE_RECORDING')"
                icon="fa fa-microphone"
                @click="finishRecording"
              ></el-button>
              <span style="margin-left: 10px" slot="tip" class="el-upload__tip">{{
                $t("UPLOAD.PRESS_RECORDING_END")
              }}</span>
            </div>
            <audio controls :src="blobURL"></audio>
          </div>
        </div>
        <div v-if="data.questions[0].type === 7">
          <p>{{ $t("ITEM.QUESTION") }} - {{ $t("QUESTION.CONNECTION") }}</p>
          <p
            v-if="(studentAnswerLogIndex !== -1 || answerSubmitted) && type === 'STUDENT'"
            style="color: red"
          >
            {{ $t("STUDENT_LECTURE.SUB_COM") }}
          </p>
          <div
            v-show="
              data.questions[0].question_material &&
              data.questions[0].question_material.length > 0
            "
          >
            <div
              class="questionFile"
              v-for="file in data.questions[0].question_material"
              :key="file.file_guid"
            >
              <img
                v-if="
                  ['.jpg', '.png', '.gif', '.JPG', '.PNG', '.GIF'].includes(
                    file.file_type
                  )
                "
                :src="getUrl(file.client_path)"
                width="100%"
              />
              <div class="questionNoteWrap">
                <video
                  v-if="['.mp4', '.MP4'].includes(file.file_type)"
                  :src="getUrl(file.client_path)"
                  controls
                ></video>
              </div>
            </div>
          </div>
          <div
            class="videoPlayer"
            v-if="data.questions[0].question_media_type === 'youtube'"
          >
            <iframe
              width="100%"
              :src="`https://www.youtube.com/embed/${youtubeId(
                data.questions[0].question_media
              )}?mute=1&autoplay=1&modestbranding=1`"
              frameborder="0"
              allowfullscreen
            >
            </iframe>
          </div>
          <pre>{{ data.questions[0].question }}</pre>

          <el-row>
            <el-col :span="11" id="canvasColLeft">
              <div
                v-for="index in getArray(data.questions[0].choice.length)"
                :key="index + 8979421"
                style="min-height: 50px"
              >
                <span
                  v-if="
                    data.questions[0].multi_choice_media_type === 'none' ||
                    data.questions[0].multi_choice_media_type === undefined ||
                    data.questions[0].multi_choice_media_type === null
                  "
                  style="vertical-align: top"
                >
                  {{ String.fromCharCode(index + 97) }} .
                  {{ data.questions[0].choice[index] }}
                </span>
                <el-row style="margin-bottom: 5px">
                  <span
                    v-if="
                      data.questions[0].multi_choice_media_type !== 'none' &&
                      data.questions[0].multi_choice_media_type !== undefined &&
                      data.questions[0].multi_choice_media_type !== null
                    "
                    :style="`vertical-align: top; ${
                      ['youtube', 'image'].includes(
                        data.questions[0].multi_choice_media_type
                      )
                        ? 'height: 198px;'
                        : 'height: 90px;'
                    }`"
                  >
                    {{ String.fromCharCode(index + 97) }} .
                  </span>
                  <div
                    class="videoPlayer"
                    v-if="
                      data.questions[0].multi_choice_media_type === 'youtube' &&
                      data.questions[0].choice[index] !== '' &&
                      data.questions[0].choice[index] !== undefined
                    "
                  >
                    <iframe
                      style="float: right"
                      width="352"
                      :src="`https://www.youtube.com/embed/${youtubeId(
                        data.questions[0].choice[index]
                      )}?&mute=1&modestbranding=1`"
                      frameborder="0"
                      allowfullscreen
                    >
                    </iframe>
                  </div>
                  <img
                    style="float: right; width: 352px; height: 198px"
                    v-if="
                      data.questions[0].multi_choice_media_type === 'image' &&
                      data.questions[0].choice[index] !== '' &&
                      data.questions[0].choice[index] !== undefined
                    "
                    :src="getUrl(data.questions[0].choice[index])"
                    width="100%"
                  />
                  <audio
                    style="float: right; height: 90px"
                    v-if="data.questions[0].multi_choice_media_type === 'voice'"
                    :src="data.questions[0].choice[index]"
                    controls
                  ></audio>
                </el-row>
              </div>
            </el-col>
            <el-col :span="6" id="canvasCol">
              <canvas id="canvas"></canvas>
            </el-col>
            <el-col :span="7">
              <div
                v-for="index in getArray(data.questions[0].choice2.length)"
                :key="index + refreshCount"
                :style="`height: ${
                  canvas === null ? 50 : canvas.height / 5
                }px; display: table;`"
              >
                <div style="display: table-cell; vertical-align: middle">
                  {{
                    String.fromCharCode(index + 65) +
                    ". " +
                    data.questions[0].choice2[index]
                  }}
                </div>
              </div>
            </el-col>
          </el-row>
        </div>
        <el-row type="flex" justify="center" v-if="!$listeners['isPreview']">
          <el-button type="primary" @click="preOnClick()" :disabled="data.type === 7">
            {{ $t("STUDENT_MENU.SUBMIT") }}
          </el-button>
        </el-row>
        <div v-else>
          <br />
          <div v-if="$listeners['answerShow']" style="margin-left: 10px;">
            {{ `답안: ${showAnswer}` }}
          </div>
          <br />
        </div>
      </div>
      <div v-if="data.type === 1">
        <div v-if="data.surveys[0].type === 0">
          <template
            v-if="
              data.surveys[0].student_surveys.length > 0 &&
              type === 'STUDENT' &&
              data.result === 1
            "
          >
            <p>{{ $t("STUDENT_LECTURE.SUB_COM") }}</p>
          </template>
          <template v-else>
            <p>{{ $t("ITEM.SURVEY") }} - {{ $t("SURVEY.MULTI_CHOI") }}</p>
            <p
              v-if="
                (data.surveys[0].student_surveys.length > 0 || answerSubmitted) &&
                type === 'STUDENT'
              "
              style="color: red"
            >
              {{ $t("STUDENT_LECTURE.SUB_COM") }}
            </p>
            <pre>{{ data.surveys[0].comment }}</pre>
            <el-radio-group v-model="answer[0]" style="width: 100%">
              <div v-for="(choice, index) in data.surveys[0].choice" :key="index">
                <el-radio :label="index">{{ index + 1 }} . {{ choice }}</el-radio>
              </div>
            </el-radio-group>
          </template>
        </div>
        <div v-if="data.surveys[0].type === 1">
          <template
            v-if="
              data.surveys[0].student_surveys.length > 0 &&
              type === 'STUDENT' &&
              data.result === 1
            "
          >
            <p>{{ $t("STUDENT_LECTURE.SUB_COM") }}</p>
          </template>
          <template v-else>
            <p>{{ $t("ITEM.SURVEY") }} - {{ $t("SURVEY.ESSAY") }}</p>
            <p
              v-if="
                (data.surveys[0].student_surveys.length > 0 || answerSubmitted) &&
                type === 'STUDENT'
              "
              style="color: red"
            >
              {{ $t("STUDENT_LECTURE.SUB_COM") }}
            </p>
            <pre>{{ data.surveys[0].comment }}</pre>
            <el-input
              :placeholder="$t('QUESTION.ENTER_CON')"
              v-model="answer[0]"
              :maxlength="limitLength"
            >
            </el-input>
          </template>
        </div>
        <el-row type="flex" justify="center" v-if="!$listeners['isPreview']">
          <el-button
            v-if="
              !(
                (data.surveys[0].student_surveys.length > 0 &&
                  type === 'STUDENT' &&
                  data.result === 1) ||
                (data.result === 1 && answerSubmitted)
              )
            "
            type="primary"
            @click="preOnClick()"
          >
            {{ $t("STUDENT_MENU.SUBMIT") }}
          </el-button>
        </el-row>
        <div v-else><br /><br /></div>
      </div>
      <div v-if="data.type === 2" class="practice">
        <p>{{ $t("PRACTICE.PRACT_ITEM") }}</p>
        <el-button
          v-if="this.authType === 1"
          style="float: right"
          size="small"
          @click="savePythonCode"
          >ipynb {{ $t("PROGRAM.SAVE") }}</el-button
        >
        <h3 style="margin: 20px">
          /practice_item_{{ practiceId }}/{{ practiceId }}.ipynb
        </h3>
        <el-row type="flex" justify="center">
          <el-button type="primary" @click="openJupyter()"> To JupyterHub </el-button>
        </el-row>
        <pre>{{ data.lecture_code_practices[0].code }}</pre>
        <el-table
          v-if="authType === 1 || data.result === 1"
          :data="similarityScores"
          height="540px"
          :border="true"
          :row-class-name="tRCName"
        >
          <el-table-column :label="$t('REG.NAME_LABEL')" prop="name" align="center" />
          <el-table-column
            :label="$t('PRACTICE.CODE')"
            prop="code_score"
            width="80px"
            align="center"
          />
          <el-table-column
            :label="$t('PRACTICE.REFRESH')"
            prop="datetime"
            width="120px"
            align="center"
          />
          <el-table-column label="-" width="120px" align="center">
            <template slot-scope="scope">
              <el-dialog
                :title="$t('PRACTICE.DIFFERENCE')"
                :visible.sync="centerDialogVisible"
                width="40%"
                :modal="false"
              >
                <el-table :data="swCode" height="300">
                  <el-table-column
                    prop="code"
                    :label="$t('PRACTICE.STUDENT')"
                  ></el-table-column>
                </el-table>
                <el-button
                  type="small"
                  align="center"
                  style="margin: 0px 10px 0px 0px"
                  @click="centerDialogVisible = false"
                  >{{ $t("DASHBOARD.QUIT") }}</el-button
                >
              </el-dialog>
              <el-button
                size="small"
                slot="reference"
                @click="viewCode(scope.row, data.lecture_code_practices[0].code)"
                >{{ $t("PRACTICE.VIEW") }}</el-button
              >
              <el-dialog
                :title="$t('PRACTICE.STUDENT')"
                :visible.sync="centerDialogVisible"
                width="40%"
                :modal="false"
              >
                <el-table :data="swCode" height="300">
                  <el-table-column
                    prop="code"
                    :label="$t('PRACTICE.STUDENT')"
                  ></el-table-column>
                </el-table>
                <el-button
                  type="small"
                  align="center"
                  style="margin: 0px 10px 0px 0px"
                  @click="centerDialogVisible = false"
                  >{{ $t("DASHBOARD.QUIT") }}</el-button
                >
              </el-dialog>
            </template>
          </el-table-column>
        </el-table>
      </div>
      <div v-if="data.type === 3" class="discuss">
        <p>{{ $t("ITEM.DISCUSSION") }}</p>
        <discussion :lectureItemId="data.lecture_item_id" />
      </div>
      <div v-if="data.type === 4" class="note">
        <p>{{ $t("ITEM.NOTE") }}</p>
        <br />
        <div v-if="data.notes[0].note_type === 0">
          <img :src="Url" width="100%" />
        </div>
        <div v-if="data.notes[0].note_type === 1" class="noteWrap">
          <iframe frameborder="0" :src="Url"></iframe>
        </div>
        <div v-if="data.notes[0].note_type === 2">
          <a :href="Url" target="_blank">{{ data.notes[0].url }}</a>
        </div>
        <div v-if="data.notes[0].note_type === 3" class="noteWrap">
          <iframe allow="autoplay" frameborder="0" :src="Url" allowfullscreen></iframe>
        </div>
      </div>
      <div v-if="data.type === 5" class="practice">
        <p>{{ $t("CODING.CODING_ASSIGN") }}</p>
        <el-button
          v-if="this.authType === 1"
          style="float: right"
          size="small"
          @click="savePythonCode"
          >ipynb {{ $t("PROGRAM.SAVE") }}</el-button
        >
        <h3 style="margin: 20px">
          /practice_item_{{ practiceId }}/{{ practiceId }}.ipynb
        </h3>
        <el-row type="flex" justify="center">
          <el-button type="primary" @click="openJupyter()"> To JupyterHub </el-button>
        </el-row>
        <pre>{{ data.lecture_code_practices[0].code }}</pre>
        <el-table
          v-if="authType === 1 || data.result === 1"
          :data="similarityScores"
          height="540px"
          :border="true"
          :row-class-name="tRCName"
        >
          <el-table-column :label="$t('REG.NAME_LABEL')" prop="name" align="center" />
          <el-table-column
            :label="$t('PRACTICE.SCORE')"
            prop="output_score"
            width="80px"
            align="center"
          />
          <el-table-column
            :label="$t('PRACTICE.REFRESH')"
            prop="datetime"
            width="160px"
            align="center"
          />
        </el-table>
      </div>
    </div>
    <el-dialog
      :visible.sync="currentFile.visible"
      :before-close="handleClose"
      custom-class="dialog"
    >
      <div v-if="currentFile.type === `.mp4`">
        <vue-plyr ref="player">
          <video>
            <source :src="exampleFileUrl" type="video/mp4" />
          </video>
        </vue-plyr>
      </div>
      <div v-else-if="['.jpg', '.png', '.gif'].includes(currentFile.type)">
        <img :src="exampleFileUrl" width="100%" />
      </div>
      <div v-else>
        <a :href="exampleFileUrl" target="_blank" download>{{ currentFile.name }}</a>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { getIdFromURL } from "vue-youtube-embed";
import deepCopy from "deep-copy";
import Discussion from "./NNDiscussion";
import { baseUrl, dockerUrl } from "../../services/config";
import utils from "../../utils";
import lectureItemService from "../../services/lectureItemService";
import classService from "../../services/classService";
import authService from "../../services/authService";
import practiceService from "../../services/practiceService";
import fileService from "../../services/fileService";
import codingService from "../../services/codingService";
import lectureService from "../../services/lectureService";
import { isArray } from "util";

export default {
  async created() {
    const vm = this;
    vm.userId = utils.getUserIdFromJwt();
    const classPort = await classService.getClass({
      id: vm.classId,
    });
    vm.portNum = classPort.data.portNum;

    const scores = await lectureItemService.getSimilarityScores({
      itemId: vm.data.lecture_item_id,
    });
    vm.similarityScores = scores.data;
    // file name error 대신 미제출로
    vm.similarityScores.forEach((x) => {
      if (x.code_score === -1) {
        x.code_score = "미제출"; // eslint-disable-line
      }
      if (x.output_score === -1) {
        x.output_score = "미제출"; // eslint-disable-line
      }
    });

    vm.practiceId = vm.data.lecture_item_id;
    const res1 = await lectureItemService.getLectureItem({
      lectureItemId: vm.data.lecture_item_id,
    });
    if (res1.data.limit_length === null) {
      vm.limitLength = 9999999999;
    } else {
      vm.limitLength = res1.data.limit_length;
    }
    if (
      vm.data.questions.length !== 0 &&
      vm.data.questions[0].multi_choice_media_type === "voice"
    ) {
      // 음성 - guid -> blobURL 변환
      if (vm.data.questions[0].choice instanceof Array) {
        for (const [index, guid] of vm.data.questions[0].choice.entries()) {
          const file = await fileService.getFile({ guid });
          const blobURL = await URL.createObjectURL(file.data);
          vm.data.questions[0].choice.splice(index, 1, blobURL);
        }
      }
    }
    if (
      vm.data.questions.length !== 0 &&
      vm.data.questions[0].question_media_type === "voice"
    ) {
      // 음성 - guid -> blobURL 변환
      const file = await fileService.getFile({
        guid: vm.data.questions[0].question_media,
      });
      vm.data.questions[0].question_media = await URL.createObjectURL(file.data);
    }
    /*
    if (vm.Type === 5) { 코딩 과제 : 변경전
      const classPort = await classService.getClass({
        id: vm.classId,
      });
      vm.portNum = classPort.data.portNum;
    } */
    if (vm.Type === 0) {
      // question이 아닌데 요청하는 문제 해결 200410
      vm.data.questions[0].answer.forEach((x) => {
        const tmp = {};
        tmp.answer = x;
        vm.saveAnswerList1.push(tmp);
      });
    }

    vm.saveAnswerList2 = deepCopy(vm.saveAnswerList1);
    vm.saveAnswerList3 = deepCopy(vm.saveAnswerList1);
    vm.saveAnswerList4 = deepCopy(vm.saveAnswerList1);
    vm.saveAnswerList5 = deepCopy(vm.saveAnswerList1);
  },
  /*async beforeUpdate() { // created나 mounted일 경우, data값 불러오지 못함
    const vm = this;
    const classPort = await classService.getClass({
      id: vm.classId,
    });
    vm.portNum = classPort.data.portNum;
    const scores = await lectureItemService.getSimilarityScores({
      itemId: vm.data.lecture_item_id,
    });
    console.log("ㅅㅂ similarity");
    vm.similarityScores = scores.data;
    // file name error 대신 미제출로
    vm.similarityScores.forEach((x) => {
      if (x.code_score === -1) {
        x.code_score = '미제출'; // eslint-disable-line
      }
      if (x.output_score === -1) {
        x.output_score = '미제출'; // eslint-disable-line
      }
    });
    vm.practiceId = vm.data.lecture_item_id;
    /*
    if (vm.Type === 5) {
      const classPort = await classService.getClass({
        id: vm.classId,
      });
      vm.portNum = classPort.data.portNum;
      }
    
    const res1 = await lectureItemService.getLectureItem({
      lectureItemId: vm.data.lecture_item_id,
    });
    console.log("ㅅㅂ getitem");
    if (res1.data.limit_length === null) {
      vm.limitLength = 9999999999;
    } else {
      vm.limitLength = res1.data.limit_length;
    }
  }, */
  async mounted() {
    const vm = this;
    if (vm.data.questions || vm.data.questions[0].type === 7) {
      vm.$nextTick(() => {
        vm.drawCanvas();
      });
    }
  },
  watch: {
    data(o, n) {
      const vm = this;
      if (vm.data.questions || vm.data.questions[0].type === 7) {
        vm.$nextTick(() => {
          vm.drawCanvas();
        });
      }
    },
  },
  props: ["lectureType", "data", "onClick", "type", "answerSubmitted"],
  data() {
    return {
      answer: [],
      canvas: null,
      selectEls: [],
      connections: [null, null, null, null, null],
      refreshCount: 0,
      mouseDownLock: false,
      rectR: 3,
      rectRHighlight: 7,
      answerFile: [],
      currentFile: {
        visible: false,
        name: undefined,
        type: undefined,
        path: undefined,
        player: undefined,
      },
      similarityScores: [],
      assignmentScores: [],
      input: {
        assignmentName: "",
      },
      practiceId: "", // 실습 아이템 id
      portNum: "", // 포트번호 (주피터 연결용)
      userId: "",
      ssCode: [],
      swCode: [], // 학생 코드 전체
      llCode: [],
      sssCode: [],
      lllCode: [],
      centerDialogVisible: false,
      isRecording: false, // 현재 녹음중인가?
      blobURL: "", // 제출 음성답안을 학생이 확인할때 씀
      recorder: undefined,
      limitLength: null,
      saveAnswer1: [], // 연결형 보기 1번에 대한 정답 저장
      saveAnswer2: [], // 연결형 보기 2번에 대한 정답 저장
      saveAnswer3: [], // 연결형 보기 3번에 대한 정답 저장
      saveAnswer4: [], // 연결형 보기 4번에 대한 정답 저장
      saveAnswer5: [], // 연결형 보기 5번에 대한 정답 저장
      saveAnswerList1: [], // 연결형 보기 저장
      saveAnswerList2: [], // 연결형 보기 저장
      saveAnswerList3: [], // 연결형 보기 저장
      saveAnswerList4: [], // 연결형 보기 저장
      saveAnswerList5: [], // 연결형 보기 저장
    };
  },
  computed: {
    /*
    Type() {
      const vm = this;
      return vm.data.type;
    },
    */
    Url() {
      const vm = this;
      if (vm.data.type === 4) {
        if (vm.data.notes[0].note_type === 0) {
          const url = baseUrl + vm.data.notes[0].files[0].client_path;
          return url;
        }
        if (vm.data.notes[0].note_type === 1) {
          const url = baseUrl + vm.data.notes[0].files[0].client_path;
          return `https://docs.google.com/gview?url=${url}&embedded=true`;
        }
        if (vm.data.notes[0].note_type === 2) {
          return vm.data.notes[0].url;
        }
        if (vm.data.notes[0].note_type === 3) {
          const id = getIdFromURL(vm.data.notes[0].url);
          const interval = vm.data.notes[0].youtube_interval.split("<?>");
          return `https://www.youtube.com/embed/${id}?autoplay=1&rel=0&start=${interval[0]}&end=${interval[1]}`;
        }
      }
      return "";
    },
    exampleFileUrl() {
      const vm = this;
      return baseUrl + vm.currentFile.path;
    },
    showAnswer() {
      const vm = this;
      let answer = '';

      if (vm.data.questions[0].answer !== undefined) {
        switch(vm.data.questions[0].type) {
          case 0: case 1: case 2: case 4:
            answer = vm.data.questions[0].answer.join(", ");
            break;
          case 3:
            answer = vm.data.questions[0].sample_code;
            break;
          case 6:
            answer = '멀티미디어는 공개할 답안이 없습니다.';
            break;
          case 7:
            answer = vm.data.questions[0].answer.map((answer, index) => {
              const alpha = String.fromCharCode(97 + index);
              const beta = String.fromCharCode(59 + Number(answer));
              return `${alpha} - ${beta}`
            }).join(", ");
            break;
        }
      }

      return answer;
    },
    studentAnswerLogIndex() {
      const vm = this;
      const userId = utils.getUserIdFromJwt();
      const slog = vm.data.questions[0].student_answer_logs;
      return slog.findIndex((item) => item.student_id === userId);
    },
    studentAnswerLogIndexSurvey() {
      const vm = this;
      const userId = utils.getUserIdFromJwt();
      const slog = vm.data.surveys[0].student_surveys;
      return slog.findIndex((item) => item.student_id === userId);
    },
    authType() {
      const vm = this;
      const jwt = vm.$store.state.auth.jwt;
      return utils.getAuthTypeFromJwt(jwt);
    },
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.query.classId, 10);
    },
  },
  methods: {
    youtubeId(URL) {
      return URL !== undefined ? getIdFromURL(URL) : "";
    },
    getArray(num) {
      let indexArray = [];
      for (let i = 0; i < num; i++) {
        indexArray.push(i);
      }
      return indexArray;
    },
    drawCanvas() {
      const vm = this;
      if (vm.data.questions[0] === undefined || vm.data.questions[0].type !== 7) {
        return;
      }
      vm.canvas = document.getElementById("canvas");
      if (vm.canvas === undefined || vm.canvas === null) {
        vm.$nextTick(() => {
          setTimeout(vm.drawCanvas, 100);
        });
      } else if (vm.canvas.getContext) {
        // 캔버스 크기 정하기;
        const canvasCol = document.getElementById("canvasCol");
        const canvasColLeft = document.getElementById("canvasColLeft");
        vm.$nextTick(() => {
          let ctx = vm.canvas.getContext("2d");
          vm.canvas.width = canvasCol.offsetWidth;
          vm.canvas.height = ["youtube", "image"].includes(
            vm.data.questions[0].multi_choice_media_type
          )
            ? 990
            : vm.data.questions[0].multi_choice_media_type === "voice"
            ? 450
            : 250;
          vm.refreshCount += 1;
          canvasCol.style.maxHeight = `${vm.canvas.height}px`;
          vm.drawLines(ctx);
          vm.refreshCount += 1;
          vm.canvas.addEventListener("mousedown", function (e) {
            if (vm.mouseDownLock === false) {
              vm.mouseDownLock = true;
              setTimeout(() => {
                vm.mouseDownLock = false;
              }, 100);
              const elNum = vm.getClickElement(vm.getCursorPosition(e));
              if (elNum > 0) {
                vm.updateSelectEl(elNum);
                vm.refreshMatching();
                vm.drawLines(ctx);
              }
            }
          });
        });
      }
    },
    updateSelectEl(elNum) {
      const vm = this;
      if (elNum < 6) {
        vm.selectEls[0] = elNum;
      } else {
        vm.selectEls[1] = elNum;
      }
    },
    refreshMatching() {
      const vm = this;
      if (
        vm.selectEls.length > 1 &&
        vm.selectEls[0] !== null &&
        vm.selectEls[1] !== null
      ) {
        vm.connections[vm.selectEls[0] - 1] = vm.selectEls[1];
        vm.selectEls = [null, null];
      }
    },
    getClickElement({ x, y }) {
      const vm = this;
      // 캔버스에서 음수, 초과값 등이 떠서 처리
      const X = x <= 0 ? 1 : x > vm.canvas.width ? vm.canvas.width : x;
      const Y = y <= 0 ? 1 : y > vm.canvas.height ? vm.canvas.height : y;
      const index = [1, 2, 3, 4, 5];
      let YNum = Math.ceil((Y * 5) / vm.canvas.height);
      let XNum =
        X <= (vm.canvas.width * 2) / 5 ? 0 : X >= (vm.canvas.width * 3) / 5 ? 1 : -1;
      if (
        (XNum === 0 && YNum > vm.data.questions[0].choice.length) ||
        (XNum === 1 && YNum > vm.data.questions[0].choice2.length)
      ) {
        XNum = -1;
      }
      return XNum * 5 + YNum;
    },
    getCursorPosition(event) {
      const vm = this;
      const rect = vm.canvas.getBoundingClientRect();
      const x = event.clientX - rect.left;
      const y = event.clientY - rect.top;
      return { x, y };
    },
    drawLines(ctx) {
      const vm = this;
      // canvas 초기화
      ctx.clearRect(0, 0, vm.canvas.width, vm.canvas.height);
      vm.drawDotEls(ctx);
      for (let i = 0; i < 5; i++) {
        // eslint-disable-line
        if (vm.connections[i] !== undefined && Number.isInteger(vm.connections[i])) {
          const start = vm.dotElsPosition(i + 1);
          const end = vm.dotElsPosition(vm.connections[i]);
          ctx.beginPath();
          ctx.moveTo(start.x, start.y);
          ctx.lineTo(end.x, end.y);
          ctx.stroke();
        }
      }
      let forEachCount = 1;
      vm.connections.forEach((matching) => {
        if (matching !== null) {
          const start = vm.dotElsPosition(forEachCount);
          const end = vm.dotElsPosition(matching);
          ctx.beginPath();
          ctx.moveTo(start.x, start.y);
          ctx.lineTo(end.x, end.y);
          ctx.stroke();
        }
        forEachCount += 1;
      });
    },
    drawDotEls(ctx) {
      const vm = this;
      for (let i = 1; i < vm.data.questions[0].choice.length + 1; i++) {
        //eslint-disable-line
        ctx.moveTo(vm.dotElsPosition(i).x, vm.dotElsPosition(i).y);
        ctx.beginPath();
        ctx.arc(
          vm.dotElsPosition(i).x,
          vm.dotElsPosition(i).y,
          vm.selectEls[0] === i ? vm.rectRHighlight : vm.rectR,
          0,
          2 * Math.PI
        );
        ctx.fillStyle = vm.selectEls[0] === i ? "red" : "black";
        ctx.fill();
      }
      for (let i = 6; i < vm.data.questions[0].choice2.length + 6; i++) {
        //eslint-disable-line
        ctx.moveTo(vm.dotElsPosition(i).x, vm.dotElsPosition(i).y);
        ctx.beginPath();
        ctx.arc(
          vm.dotElsPosition(i).x,
          vm.dotElsPosition(i).y,
          vm.selectEls[0] === i ? vm.rectRHighlight : vm.rectR,
          0,
          2 * Math.PI
        );
        ctx.fillStyle = vm.selectEls[0] === i ? "red" : "black";
        ctx.fill();
      }
    },
    dotElsPosition(num) {
      const vm = this;
      const heightNum = num > 5 ? num - 5 : num;
      let x = num < 6 ? vm.canvas.width / 5 : (vm.canvas.width * 4) / 5;
      let y = (vm.canvas.height * (2 * heightNum - 1)) / 10;
      return { x, y };
    },
    // async openJupyter() { // 주피터 열기
    //   const vm = this;
    //   if (vm.portNum === 0 || vm.portNum === null) {
    //     vm.$notify({
    //       title: vm.$t('NOTIFY.TITLE'),
    //       message: vm.$t('NOTIFY.NOT_CONN_JUPY'),
    //       type: 'warning',
    //     });
    //     return;
    //   }
    //   if (vm.authType === 0) {
    //     // 학생
    //     const userr = await authService.returnUserInfo({
    //       userID: vm.userId,
    //     });
    //     const student_docker_page= window.open(dockerUrl + ':' + vm.portNum + '/hub/preswotlogin?user=' + userr.data.userInfo.email_id, '_blank', 'width=800, height=600'); // eslint-disable-line
    //     student_docker_page.focus();
    //     student_docker_page.location.href = dockerUrl+':'+ vm.portNum +'/user/'+userr.data.userInfo.email_id+'/tree/practice_item_' +vm.data.lecture_item_id;
    //   } else if (vm.authType === 1) {
    //     // 강사
    //     const educator_docker_page = window.open(dockerUrl + ':' + vm.portNum + '/hub/preswotlogin?user=' + 'educator', '_blank', 'width=800, height=600'); // eslint-disable-line
    //     educator_docker_page.focus();
    //     educator_docker_page.location.href = dockerUrl + ':' + vm.portNum + '/user/educator/tree/' + 'practice_item_' +vm.data.lecture_item_id;
    //   }
    // },
    // 2021-03-16 주피터 허브용 코드
    async openJupyter() {
      // 주피터 열기
      const vm = this;
      if (vm.portNum === 0 || vm.portNum === null) {
        vm.$notify({
          title: vm.$t("NOTIFY.TITLE"),
          message: vm.$t("NOTIFY.NOT_CONN_JUPY"),
          type: "warning",
        });
        return;
      }

      const jupyterhubUrl = dockerUrl + ":" + vm.portNum + "/hub/login?next=%2Fhub%2F"; // jupyterhub 로그인 URL
      const masterPassword = "elql2716"; //jupyterhub 마스터키

      // 학생
      if (vm.authType === 0) {
        const userr = await authService.returnUserInfo({
          userID: vm.userId,
        });

        // 학생이 접속 할 경우 portNum이 0으로 들어오는 경우가 발생하여 다시 가져옴
        const classPort = await classService.getClass({
          id: vm.classId,
        });

        const studentJupyterhubUrl =
          dockerUrl + ":" + classPort.data.portNum + "/hub/login?next=%2Fhub%2F"; // jupyterhub 로그인 URL

        var form = document.createElement("form");
        form.setAttribute("method", "post");
        form.setAttribute("action", studentJupyterhubUrl);
        form.setAttribute("target", "student_hub");

        var input = document.createElement("input");
        input.type = "hidden";
        input.name = "username";
        input.value = userr.data.userInfo.email_id;
        form.appendChild(input);

        input = document.createElement("input");
        input.type = "hidden";
        input.name = "password";
        input.value = masterPassword;
        form.appendChild(input);
        document.body.appendChild(form);

        const student_docker_page = window.open(
          studentJupyterhubUrl,
          "student_hub",
          "width=800, height=600"
        ); // eslint-disable-line        student_docker_page.focus();

        form.submit();
        document.body.removeChild(form);
      } // 강사
      else if (vm.authType === 1) {
        var form = document.createElement("form");
        form.setAttribute("method", "post");
        form.setAttribute("action", jupyterhubUrl);
        form.setAttribute("target", "educator_hub");

        var input = document.createElement("input");
        input.type = "hidden";
        input.name = "username";
        input.value = "admin";
        form.appendChild(input);

        input = document.createElement("input");
        input.type = "hidden";
        input.name = "password";
        input.value = masterPassword;
        form.appendChild(input);

        document.body.appendChild(form);
        const educator_docker_page = window.open(
          jupyterhubUrl,
          "educator_hub",
          "width=800, height=600"
        ); // eslint-disable-line

        form.submit();
        document.body.removeChild(form);
      }
    },
    async preOnClick() {
      const vm = this;
      let arg = {};
      switch (vm.data.type) {
        case 0: // 문항
          if (vm.data.questions[0].type === 7) {
            vm.answer = vm.connections.filter((connection) => connection !== null);
            if (
              vm.connections.filter((connection) => connection !== null).length !==
              vm.data.questions[0].choice.length
            ) {
              vm.$notify({
                title: vm.$t("NOTIFY.TITLE"),
                message: vm.$t("NOTIFY.SLCT_MORE_ONE"),
                type: "warning",
              });
              return;
            }
          }
          arg = {
            type: 0,
            lectureItemId: vm.data.lecture_item_id,
            questionId: vm.data.questions[0].question_id,
            questionType: vm.data.questions[0].type,
            language: vm.data.questions[0].accept_language,
            answer: vm.answer,
          };
          if (vm.data.questions[0].type === 0 && vm.answer.length === 0) {
            vm.$notify({
              title: vm.$t("NOTIFY.TITLE"),
              message: vm.$t("NOTIFY.SLCT_MORE_ONE"),
              type: "warning",
            });
            return;
          }
          if (vm.data.questions[0].type === 1 && vm.answer.length === 0) {
            vm.$notify({
              title: vm.$t("NOTIFY.TITLE"),
              message: vm.$t("QUESTION.ENTER_CON"),
              type: "warning",
            });
            return;
          }
          if (vm.data.questions[0].type === 6) {
            // 멀티미디어
            if (vm.data.questions[0].answer_media_type === "image") {
              arg.answer_media_type = "image";
              if (
                vm.$refs.answerUpload.uploadFiles !== undefined &&
                vm.$refs.answerUpload.uploadFiles.length !== 0
              ) {
                arg.answerFile = vm.$refs.answerUpload.uploadFiles[0].raw;
              } else {
                vm.$notify({
                  title: vm.$t("NOTIFY.TITLE"),
                  message: vm.$t("NOTIFY.ATTACH_FILE"),
                  type: "warning",
                });
                return;
              }
            } else if (vm.data.questions[0].answer_media_type === "voice") {
              arg.answer_media_type = "voice";
              arg.answerFile = vm.answerFile;
            }
          }
          break;
        case 1: // 설문
          arg = {
            type: 1,
            lectureItemId: vm.data.lecture_item_id,
            surveyId: vm.data.surveys[0].survey_id,
            surveyType: vm.data.surveys[0].type,
            answer: vm.answer,
          };
          if (vm.data.surveys[0].type === 0 && vm.answer.length === 0) {
            vm.$notify({
              title: vm.$t("NOTIFY.TITLE"),
              message: vm.$t("NOTIFY.SLCT_ONE_CHOI"),
              type: "warning",
            });
            return;
          }
          if (vm.data.surveys[0].type === 1 && vm.answer.length === 0) {
            vm.$notify({
              title: vm.$t("NOTIFY.TITLE"),
              message: vm.$t("QUESTION.ENTER_CON"),
              type: "warning",
            });
            return;
          }
          break;
        default:
          break;
      }
      await vm.onClick("SUBMIT", arg, vm.indexOnPage !== undefined ? vm.indexOnPage : 0);
      vm.clearAnswer();
    },
    onChange(data) {
      // 문항 - 객관값 보정 (0 1 2 3 4를 1 2 3 4 5로) 을 위한 함수
      const vm = this;
      vm.answer = data + 1;
    },
    clearAnswer() {
      const vm = this;
      vm.answer = [];
      if (vm.data.questions[0] && vm.data.questions[0].type === 6) {
        // 멀티미디어
        if (vm.data.questions[0].answer_media_type === "image") {
          vm.$refs.answerUpload.clearFiles();
        }
      }
    },
    handleVisible(file) {
      // eslint-disable-line consistent-return
      const vm = this;
      vm.currentFile.name = file.name;
      vm.currentFile.type = file.file_type;
      vm.currentFile.path = file.client_path;
      if ([".mp4", ".jpg", ".png", ".gif"].includes(vm.currentFile.type)) {
        vm.currentFile.visible = true;
      } else {
        utils.downloadFile(vm.url, vm.currentFile.name);
      }
      if (vm.data.notes[0].note_type === 3) {
        const id = getIdFromURL(vm.data.notes[0].url);
        const interval = vm.data.notes[0].youtube_interval.split("<?>");
        // 자동재생 안되게 막음. 강의은행에서 '미리보기' 기능때문에 모든 유튜브 아이템이 다 출력됨 190401 수정
        return `https://www.youtube.com/embed/${id}?autoplay=0&rel=0&start=${interval[0]}&end=${interval[1]}`;
      }
    },
    handleClose() {
      const vm = this;
      vm.currentFile.visible = false;
      if (vm.currentFile.type === ".mp4") {
        vm.currentFile.player = vm.$refs.player.player;
        vm.currentFile.player.stop();
      }
    },
    getUrl(arg) {
      return baseUrl + arg;
    },
    async checkAssignment() {
      const vm = this;
      const lectureItemId = vm.data.lecture_item_id;
      // await 해제 - 190426
      lectureItemService.getAssignmentScores({
        classId: vm.classId,
        itemId: lectureItemId,
      });
      const scores = await lectureItemService.reloadAssignmentScores({
        classId: vm.classId,
        itemId: lectureItemId,
      });
      vm.assignmentScores = scores.data;
    },
    tRCName({ row }) {
      if (row.group % 2 === 1) {
        return "odd";
      }
      return "even";
    },
    // 코드 차이
    async viewCodeDiff(row, lCode) {
      const vm = this;
      // 코드 미제출 시
      vm.centerDialogVisible = true;
      vm.llCode = [];
      vm.ssCode = [];
      vm.swCode = [];
      if (row.code_score === "미제출") {
        vm.$notify({
          title: vm.$t("NOTIFY.TITLE"),
          message: vm.$t("NOTIFY.NO_COD_REG"),
          type: "warning",
        });
      } else if (row.code_score === 1) {
        vm.$notify({
          title: vm.$t("NOTIFY.TITLE"),
          message: vm.$t("NOTIFY.IDENT_INST_COD"),
          type: "warning",
        });
      } else {
        const studentCode = await practiceService.getCode({
          email_id: row.email_id,
          item_id: vm.data.lecture_item_id,
          class_id: vm.classId,
        });
        const sCode = studentCode.data.codeResult[0].code;
        // 코드 비교 시작
        const sCode1 = sCode.split("\n");
        const lCode1 = lCode.split("\n");
        let checkLongComment = false;
        const newSCode = [];
        const newLCode = [];
        sCode1.forEach((x) => {
          x = x.trim(); // eslint-disable-line
          // 앞 뒤 공백 제거
          x = x.replace(/ +/g, ""); // eslint-disable-line
          // 여러 공백을 하나로
          if (x.length !== 0 && checkLongComment === false) {
            // 빈 줄 아니고 주석의 일부 아니어야 함
            let realCode = x;
            // 주석 제외
            if (x.includes("#")) {
              realCode = realCode.split("#")[0];
            } else if (x.includes("'''")) {
              // 주석의 시작
              realCode = realCode.split("'''")[0];
              checkLongComment = true;
            }
            if (realCode.length !== 0) {
              const tmp = {};
              tmp.err = false;
              tmp.check = false;
              tmp.code = realCode;
              newSCode.push(tmp);
            }
          } else if (checkLongComment === true) {
            // Long 주석이 끝났나 탐색
            if (x.includes("'''")) {
              checkLongComment = false;
            }
          }
        });
        checkLongComment = false;
        lCode1.forEach((x) => {
          x = x.trim(); // eslint-disable-line
          // 앞 뒤 공백 제거
          x = x.replace(/ +/g, ""); // eslint-disable-line
          // 여러 공백을 하나로
          if (x.length !== 0 && checkLongComment === false) {
            // 빈 줄 아니고 주석의 일부 아니어야 함
            let realCode = x;
            // 주석 제외
            if (x.includes("#")) {
              realCode = realCode.split("#")[0];
            } else if (x.includes("'''")) {
              // 주석의 시작
              realCode = realCode.split("'''")[0];
              checkLongComment = true;
            }
            if (realCode.length !== 0) {
              const tmp = {};
              tmp.err = false;
              tmp.check = false;
              tmp.code = realCode;
              newLCode.push(tmp);
            }
          } else if (checkLongComment === true) {
            // Long 주석이 끝났나 탐색
            if (x.includes("'''")) {
              checkLongComment = false;
            }
          }
        });
        let checkLine = 0;
        let flag = false;
        newLCode.forEach((x) => {
          flag = false;
          newSCode.forEach((y, index) => {
            if (y.check === false && x.code === y.code) {
              y.check = true; // eslint-disable-line
              y.err = false; // eslint-disable-line
            } else if (checkLine === index && flag === false) {
              for (let i = checkLine; i < newSCode.length; i += 1) {
                if (x.code === newSCode[i].code) {
                  newSCode[i].check = true;
                  newSCode[i].err = false;
                  checkLine = i;
                  break;
                } else if (newSCode[i].check === false && x.code !== newSCode[i].code) {
                  newSCode[i].check = true;
                  newSCode[i].err = true;
                  checkLine = i;
                }
              }
              flag = true;
            }
          });
          newSCode.forEach((y) => {
            if (y.check === true && y.err === true && x.code === y.code) {
              const tmp = {};
              tmp.code = y.code + " 강사 코드와 순서가 다릅니다."; // eslint-disable-line
              y.err = false; // eslint-disable-line
              vm.ssCode.push(tmp);
            }
          });
        });
        newSCode.forEach((x) => {
          if (x.check === true && x.err === true) {
            const tmp = {};
            tmp.code = x.code;
            vm.ssCode.push(tmp);
          }
        });
      }
    },
    // 학생 코드 보기
    async viewCode(row, lCode) {
      const vm = this;
      const educator_docker_page = window.open(
        dockerUrl + ":" + vm.portNum + "/hub/preswotlogin?user=" + "educator",
        "_blank",
        "width=800, height=600"
      ); // eslint-disable-line
      educator_docker_page.focus();
      educator_docker_page.location.href =
        dockerUrl +
        ":" +
        vm.portNum +
        "/user/" +
        row.email_id +
        "/tree/" +
        "practice_item_" +
        vm.data.lecture_item_id;

      /* 코드 미제출 시
      vm.centerDialogVisible = true;
      vm.llCode = [];
      vm.ssCode = [];
      vm.swCode = [];
      if (row.code_score === '미제출') {
        vm.$notify({
          title: vm.$t('NOTIFY.TITLE'),
          message: vm.$t('NOTIFY.NO_COD_REG'),
          type: 'warning',
        });
      } else if (row.code_score === 1) {
        vm.$notify({
          title: vm.$t('NOTIFY.TITLE'),
          message: vm.$t('NOTIFY.IDENT_INST_COD'),
          type: 'warning',
        });
      } else {
        const studentCode = await practiceService.getCode({
          email_id: row.email_id,
          item_id: vm.data.lecture_item_id,
          class_id: vm.classId,
        });
        const sCode = studentCode.data.codeResult[0].code;
        const sCodeLine = sCode.split("\n");
        sCodeLine.forEach((x) => {
          const tmp = {};
          tmp.code = x;
          vm.swCode.push(tmp);
        });
      } */
    },
    async startRecording() {
      const vm = this;
      if (vm.recording === true) {
        await vm.finishRecording();
      }
      try {
        const stream = await navigator.mediaDevices.getUserMedia({ audio: true }); // 녹음 권한 획득
        vm.recorder = new RecordRTCPromisesHandler(stream, {
          type: "audio",
        });
        vm.recorder.startRecording();
        vm.isRecording = true;
      } catch (error) {
        vm.$notify({
          title: vm.$t("NOTIFY.REC_FAIL"),
          message: vm.$t("NOTIFY.NO_EQUP_NOT_ALLW"),
          type: "error",
          duration: 0,
        });
      }
    },
    async finishRecording() {
      const vm = this;
      await vm.recorder.stopRecording();
      const audioBlob = await vm.recorder.getBlob();
      vm.blobURL = URL.createObjectURL(audioBlob);
      vm.answerFile = new File([audioBlob], "voice.webm", { type: "audio/webm" });
      vm.isRecording = false; // 현재 녹음중이 아님을 알림
    },
    handleExceed() {
      this.$message.warning("하나의 파일만 업로드 할 수 있습니다.");
    },
    async savePythonCode() {
      const vm = this;
      await codingService.postUpload({
        classId: vm.classId,
        itemId: vm.data.lecture_item_id,
      });
      vm.$notify({
        title: vm.$t("NOTIFY.TITLE"),
        message: vm.$t("NOTIFY.SUCCESS_SAV"),
        type: "success",
      });
    },
  },
  components: {
    Discussion,
  },
  // beforeDestroy() {
  //   const vm = this;
  //   // 문항 이고, 공개 여부 3인 경우
  //   if (vm.data.type === 0 && vm.data.result === 3) {
  //     switch (vm.data.questions[0].type) {
  //       case 0:
  //         vm.$notify({
  //           title: vm.$t('NOTIFY.TITLE'),
  //           message: vm.$t('NOTIFY.CRR_ANSWER_FRONT') + `${vm.data.questions[0].answer}` + vm.$t('NOTIFY.CRR_ANSWER_BACK'),
  //           type: 'warning',
  //         });
  //         break;
  //       case 1:
  //         vm.$notify({
  //           title: vm.$t('NOTIFY.TITLE'),
  //           message: vm.$t('NOTIFY.CRR_ANSWER_FRONT') + `${vm.data.questions[0].answer}` + vm.$t('NOTIFY.CRR_ANSWER_BACK'),
  //           type: 'warning',
  //         });
  //         break;
  //       case 2:
  //         vm.$notify({
  //           title: vm.$t('NOTIFY.TITLE'),
  //           message: vm.$t('NOTIFY.EXAMPLE_ANSWER_FRONT') + `${vm.data.questions[0].answer}` + vm.$t('NOTIFY.CRR_ANSWER_BACK'),
  //           type: 'warning',
  //         });
  //         break;
  //       case 4:
  //         vm.$notify({
  //           title: vm.$t('NOTIFY.TITLE'),
  //          message: vm.$t('NOTIFY.CRR_ANSWER_FRONT') + `${vm.data.questions[0].answer}` + vm.$t('NOTIFY.CRR_ANSWER_BACK'),
  //           type: 'warning',
  //         });
  //         break;
  //       default:
  //         break;
  //     }
  //   }
  // },
};
</script>

<style lang="scss">
.videoPlayer {
  position: relative;
  padding-bottom: 56.25%; /* 16:9 */
  height: 0;
}
.videoPlayer iframe {
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
}
.question-type {
  font-size: 2em;
}
.lecture-live-item-wrapper {
  pre {
    overflow-x: auto; /* Use horizontal scroller if needed; for Firefox 2, not needed in Firefox 3 */
    white-space: pre-wrap; /* css-3 */
    white-space: -moz-pre-wrap !important; /* Mozilla, since 1999 */
    white-space: -pre-wrap; /* Opera 4-6 */
    white-space: -o-pre-wrap; /* Opera 7 */
    /* width: 99%; */
    word-wrap: break-word; /* Internet Explorer 5.5+ */
  }
  .el-checkbox__label {
    white-space: pre-line; /* css-3 */
  }
  .radio-one {
    /*border:1px solid red;*/
    margin: 15px;
  }

  .lecture-item {
    /*border:1px solid green;*/
    margin: 0 0;
  }

  .lecture-item .question-box {
    padding: 5px 0 0 0;
  }

  .lecture-item p {
    /*sh : 이 경우 <p>제출이 완료되었습니다.</p>도 스타일이 적용되기 때문에 후에 분리시키는 조치가 필요함*/
    margin: 10px 0 0 10px;
    font-size: 1.1em;
  }

  .lecture-item pre {
    /*border:1px solid red;*/
    margin: 20px 0 0 15px;
  }

  /*.lecture-item span{
      <span>답 : </span> 을 아예 없애는건?
    }
    */

  .lecture-item .el-button {
    margin: 10px 0;
  }

  .lecture-item .el-input {
    margin: 20px 0 0 0;
  }

  .lecture-item .margin-text {
    /*문항 - 서술,SW*/
    margin: 20px 0 0 0;
  }

  .lecture-item .practice {
    padding: 5px 0 20px 0;
  }

  .lecture-item .discuss {
    padding: 5px 0 0 0;
    height: 530px;
  }

  .item + .item:before {
    content: ", ";
  }
  .lecture-item .note {
    padding: 10px;
    margin: 10px;
    // height:530px;
  }
  .noteWrap {
    position: relative;
    width: 100%;
    padding-bottom: 56.25%;
  }
  .noteWrap iframe {
    position: absolute;
    width: 100%;
    height: 100%;
  }
  .questionNoteWrap {
    position: relative;
    width: 100%;
  }
  .questionNoteWrap video {
    // position: absolute;
    width: 100%;
    height: 100%;
  }
  .lecture-item .questionFile {
    padding: 10px 10px 10px 10px;
    margin: 10px 10px 10px 10px;
  }
}
</style>
